#include <windows.h>
#include <stdio.h>
#include "VolumousePlugin.h"



BOOL WINAPI DllMain(
  HINSTANCE hinstDLL,
  DWORD fdwReason,
  LPVOID lpvReserved
)
{

	return TRUE;
}


const int MAX_DRIVES = 32;
const int MAX_COMPONENT_NAME = 50;

WCHAR PluginName[] = L"OpenCloseCD";
WCHAR CDDrives[MAX_DRIVES] = {0};
DWORD dwCDDrivesCount = 0;
WCHAR ComponentNames[MAX_DRIVES][MAX_COMPONENT_NAME] = {0};

void LoadCDDrivesList()
{
	dwCDDrivesCount = 0;
	DWORD dwDrives = GetLogicalDrives();

	for (DWORD dwBit = 0; dwBit < 32; dwBit++)
	{
		if (dwDrives & (1 << dwBit))
		{
			WCHAR wzDrive[4] = L"C:\\";
			wzDrive[0] = 'A' + dwBit;

			if (GetDriveType(wzDrive) == DRIVE_CDROM)
			{
				CDDrives[dwCDDrivesCount] = wzDrive[0];
				dwCDDrivesCount++;
			}
		}
	}

}

INT_PTR WINAPI VolumousePluginProc(VOLUMOUSE_PLUGIN_EVENT *pEvent)
{
	INT_PTR result = FALSE;

	switch(pEvent->EventID)
	{
		case VOLUPLUGIN_EVENT_LOAD:
			LoadCDDrivesList();

			//This event is fired when the plugin is loaded into Volumouse.
			pEvent->Load.PluginName = PluginName;
			result = TRUE;


			break;

		case VOLUPLUGIN_EVENT_UNLOAD:
			//This event is fired when the plugin is unloaded from Volumouse.
			result = TRUE;

			break;

		case VOLUPLUGIN_EVENT_ADD_COMPONENTS:
			//This event is fired when Volumouse need to display the components list.
			
			pEvent->AddComponents.Count = dwCDDrivesCount;
			
			for (DWORD dwIndex = 0; dwIndex < dwCDDrivesCount; dwIndex++)
			{
				WCHAR wzDrive[3] = L"C:";

				wzDrive[0] = CDDrives[dwIndex];
				_snwprintf(ComponentNames[dwIndex], MAX_COMPONENT_NAME, L"Open/Close %s", wzDrive);		
				pEvent->AddComponents.Components[dwIndex] = ComponentNames[dwIndex];
			}

			result = TRUE;


			break;

		case VOLUPLUGIN_EVENT_USER_ACTION:
			//This event is fired when the user moves the wheel or press
			//the hot key combination, according to the defined rules.
			WCHAR wzDrive[3] = L"C:";
			WCHAR *pOpenClose;

			if (pEvent->UserAction.Change > 0)
				pOpenClose = L"Open";
			else
				pOpenClose = L"Closed";

			wzDrive[0] = CDDrives[pEvent->UserAction.ComponentIndex];

			if (wzDrive[0] != '\0')
			{
				WCHAR wzCommand[256];

				_snwprintf(wzCommand, 255, L"open %s type cdaudio alias cd1", wzDrive);

				mciSendString(wzCommand, NULL, 0, 0);

				_snwprintf(wzCommand, 255, L"Set cd1 Door %s", pOpenClose);
				
				mciSendString(wzCommand, NULL, 0, 0);


				mciSendString(L"close cd1", NULL, 0, 0); 

			}


			break;
	}

	return result;
}
